package edu.moduli;

import java.util.ArrayList;
import java.util.List;

import org.apache.commons.configuration.SubnodeConfiguration;

import edu.moduli.exceptions.InitModuleException;
import edu.moduli.exceptions.StartModuleException;

/**
 * Structure for 
 */
public abstract class AModule
{
	// --------------------------------------------------------------------------
	// --- instance variables ---------------------------------------------------
	// --------------------------------------------------------------------------
	
	// --- module-infos ---
	private String id;
	private String type;
	private SubnodeConfiguration subnodeConfiguration;
	private List<String> dependencies = new ArrayList<String>();
	
	// --------------------------------------------------------------------------
	// --- abstract-methods -----------------------------------------------------
	// --------------------------------------------------------------------------
	
	/**
	 * Inits module.
	 */
	public abstract void initModule() throws InitModuleException;
	
	/**
	 * DeInits module.
	 */
	public abstract void deinitModule();
	
	/**
	 * Starts module.
	 */
	public abstract void startModule() throws StartModuleException;
	
	/**
	 * Stops module.
	 */
	public abstract void stopModule();
	
	// --------------------------------------------------------------------------
	// --- getter/setter --------------------------------------------------------
	// --------------------------------------------------------------------------
	
	public String getId() {
		return id;
	}

	public void setId(String id) {
		this.id = id;
	}
	
	public String getType() {
		return type;
	}

	public void setType(String type) {
		this.type = type;
	}

	public List<String> getDependencies() {
		return dependencies;
	}

	public void setDependencies(List<String> dependencies) {
		this.dependencies = dependencies;
	}

	public SubnodeConfiguration getSubnodeConfiguration() {
		return subnodeConfiguration;
	}

	void setSubnodeConfiguration(SubnodeConfiguration subnodeConfiguration) {
		this.subnodeConfiguration = subnodeConfiguration;
	}
}
